;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Global BallTexCamera
Global BallTex
Global SpriteBallTex
Global SpriteBall

;Const BallTexSize=128
Global BallTexSize=128
Const BallTexZoom#=0.5

Global fxAction=0
;----------------------------------------------------------------
;creates the texture for Real Reflecting world.
;----------------------------------------------------------------
Function createTextureBall()
		;The camera to Capture the world seen from the ball.
		BallTexCamera=CreateCamera()
		CameraViewport(BallTexCamera,0,0,BallTexSize,BallTexSize)
		CameraRange(BallTexCamera,0.0001,1000)
		CameraZoom(BallTexCamera,BallTexZoom)
		
		;the environ map Texture of the world.
		BallTex=CreateTexture(BallTexSize,BallTexSize,8+64+256)
		EntityTexture(ball\mesh,BallTex)
		
		;a in front of the BallCam to "Flip" horizonaly the Texture (like in a mirror)
		SpriteBall=CreateSprite(BallTexCamera)
		MoveEntity SpriteBall,0,0,BallTexZoom*RayonSphere
		ScaleSprite (SpriteBall,RayonSphere,RayonSphere)
		SpriteBallTex=CreateTexture(BallTexSize,BallTexSize,256)
		ScaleTexture (SpriteBallTex,-1,1) ;----->>> the hint of the mirror effect
		EntityTexture SpriteBall,SpriteBallTex
End Function
;----------------------------------------------------------------
;Draw the environment map on 1 frame by two. the 2nd frame is used to flip the texture. 
;----------------------------------------------------------------
Function doBallReflexion()
	;CameraProjMode camera,0
	HideEntity camera
	CameraProjMode BallTexCamera,1
	
	Select (fxAction)
		Case 0 :
			PrepareBallTexture()		
		Case 1 :	
			updateTextureBall()
	End Select 
	fxAction=(fxAction+1) Mod 2
	
	CameraProjMode BallTexCamera,0
	;CameraProjMode camera,1
	ShowEntity camera
End Function 
;----------------------------------------------------------------
; prepare the texture on the sprite to do the mirror effect
;----------------------------------------------------------------
Function PrepareBallTexture()
	;facing BallCamTex to the main Camera
	RotateEntity BallTexCamera,0,0,0
	PositionEntity BallTexCamera,EntityX(ball\mesh),EntityY(ball\mesh),EntityZ(ball\mesh)
	TurnEntity BallTexCamera,DeltaPitch(BallTexCamera,camera),DeltaYaw(BallTexCamera,camera),0
	RenderWorld
	CopyRect 0,0,BallTexSize,BallTexSize,0,0,0,TextureBuffer(SpriteBallTex)			
End Function
;----------------------------------------------------------------
; draw the world seen from the ball on the Environment Map texture
;----------------------------------------------------------------
Function updateTextureBall()
		ShowEntity SpriteBall
		RenderWorld
		CopyRect 0,0,BallTexSize,BallTexSize,0,0,0,TextureBuffer(BallTex)
		HideEntity SpriteBall
End Function 