;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;
Global Ball.ODE_Object

Const Force=10

Global BallCamera


Global RayonSphere#; Rayon de la Bille

;----------------------------------------------------------------
Function resetBall(Zone)
	Local Xball#,Yball#,Zball#
	;repositionement des boutons
	ResetAllAob()
	;Replace la bille sur le dernier checkPoint.
	Xball=EntityX(TabCheckPtBox[Zone])
	Yball=EntityY(TabCheckPtBox[Zone])
	Zball=EntityZ(TabCheckPtBox[Zone])
	
	ODE_PositionObject(ball\ODE_ID,ball,Xball, YBall, ZBall)
	ODE_SetBodyLinearVelocity(ball\ODE_ID, 0 , 0 , 0)
	ODE_SetBodyAngularVelocity(ball\ODE_ID, 0, 0 , 0)
End Function
;----------------------------------------------------------------
Function CreateBall()
	Ball = New ODE_Object
	Ball\obtype = 2
	ODE_CreateObject(Ball\obtype , 0 , Ball , 0 , 0 , 0 , RayonSphere*2, RayonSphere*2, RayonSphere*2, 1, False)
	ODE_RotateObject(0 , Ball,0,0,0)
	EntityShininess(ball\mesh,1)
	resetBall(0)
	;cet objet sera sauveguard pour le replay
	TabRecObj[nbRecObj]=Ball\mesh
	nbRecObj=nbRecObj+1
	
	env=LoadTexture("data\img\spheremap.bmp",64+3)
	TextureBlend(env,1)
	EntityTexture Ball\mesh,env,0,1
	If (Cfg_Reflet) Then 
		createTextureBall()
		Local colorball=255
	Else
		colorball=50		
	EndIf
	
	EntityColor(ball\mesh,colorball,colorball,colorball)
	
	;son
	ResumeChannel(ChnlBallRoll)
	ChannelVolume(ChnlBallRoll,0)
		
End Function
;----------------------------------------------------------------
; Move the ball With Cursor.
;----------------------------------------------------------------
Function FUNC_MoveBall()
	
	If KeyDown(57) Then resetBall(0)
	
	For i = 2 To 10
		If KeyDown(i) Then resetBall(i-1)
	Next 
	
	Local ForceZ%=0
	If KeyDown(200) Then ForceZ=force
	If KeyDown(208) Then ForceZ=-force
	Local ForceX%=0
	If KeyDown(205) Then ForceX=force
	If KeyDown(203) Then ForceX=-force
	
	
	TFormVector (ForceX,0,ForceZ,camera,0)
	Local Xforce=TFormedX()
	Local Yforce=TFormedY()
	Local Zforce=TFormedZ()
	
		
	ODE_Add_Relative_Force_To_Object(ball\ODE_ID,Xforce,0,Zforce,0,0,0,2)
	
	
End Function 