;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

;contitent tous les objets qui doivent tres enregistr pour le replay
Global TabRecObj[30]
Global nbRecObj%

;Liste simplement chaine Linaire.
Type TRecordObject
	Field Mesh%
	Field x#,Y#,Z#
	Field Pitch#,Yaw#,Roll#
End Type

Type TCellRecObj
	Field RecObj.TRecordObject
	Field Suiv.TCellRecObj
End Type


Global TeteList.TCellRecObj
Global FinListe.TCellRecObj
;immage courante pour le replay
Global CurentFrame.TCellRecObj=TeteList

;----------------------------------------------------------------------
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;Remet le curseur au dbut du replay.
Function ResetReplay()
	CurentFrame=TeteList
End Function
;----------------------------------------------------------------------
Function RecordFrame()
	For i=0 To nbRecObj-1
		AjouteList(GetMeshInfo(TabRecObj[i]));
	Next
End Function
;----------------------------------------------------------------------
Function PlayFrame()
	For i=0 To nbRecObj-1
		If CurentFrame<>Null Then
			SetMeshInfo(CurentFrame\RecObj)
			CurentFrame=CurentFrame\suiv
		EndIf 
	Next
End Function
;----------------------------------------------------------------------
Function EraseReplay()
	CurentFrame=TeteList
	While CurentFrame<>Null
		tmp.TCellRecObj=CurentFrame
		CurentFrame=CurentFrame\suiv
		Delete(Tmp)
	Wend 
End Function
;----------------------------------------------------------------------
;----------------------------------------------------------------------
; Gestion des infos d'un objet.
;----------------------------------------------------------------------
Function GetMeshInfo.TRecordObject(obj%)
	result.TRecordObject =New TRecordObject
		result\mesh=obj
		result\x=EntityX (obj)
		result\Y=EntityY (obj)
		result\Z=EntityZ (obj)
		result\Pitch= EntityPitch (obj)
		result\Yaw  = EntityYaw   (obj)
		result\Roll = EntityRoll  (obj)
	Return result
End Function 
;----------------------------------------------------------------------
Function SetMeshInfo.TRecordObject(obj.TRecordObject)
	PositionEntity(obj\mesh,obj\x,obj\y,obj\Z)
	RotateEntity(obj\mesh,obj\Pitch,obj\Yaw,obj\Roll)
End Function 
;----------------------------------------------------------------------
; Gestion des listes
;----------------------------------------------------------------------
Function AjouteEnFin(recObj.TRecordObject)
	FinListe\Suiv=New TCellRecObj
	Finliste=FinListe\Suiv
	Finliste\RecObj=recObj
	Finliste\suiv=Null
End Function
;----------------------------------------------------------------------
Function ajouteEnTete(recObj.TRecordObject)
	TeteList = New TCellRecObj
	TeteList\RecObj=recObj
	TeteList\suiv=Null
	Finliste = TeteList
End Function 
;----------------------------------------------------------------------
Function AjouteList(recObj.TRecordObject)
	If TeteList=Null Then 
		ajouteEnTete(recObj)
	Else 
		AjouteEnFin(recObj)
	EndIf 
End Function 