;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Global SP_MouseCursor%

Global SP_Mouse%
Global SP_MenuBorder%

Global inGameSpLayer%
Global MenuLayer%

Global MainMenu.Tmenu
Global GameMenu.Tmenu
Global GameOverMenu.Tmenu

Function SpLoadSprite(FileName$,Parent)
	Local sprite=LoadSprite(FileName,2,Parent)
	EntityOrder (sprite,-1)
	Return sprite
End Function



Function LoadGameSprite()
	;------------------------------------------
	; Sprite du curseur
	;------------------------------------------
	SP_MouseCursor=SpLoadSprite("data\img\MouseCursor.bmp",SpriteLayer)
	ScaleSprite(SP_MouseCursor,0.2,0.2)
	ScaleSprite(SP_MouseCursor,0.08,0.08)
	PositionEntity(SP_MouseCursor,10,10,0)
	EntityOrder(SP_MouseCursor,-10)	
	
	;------------------------------------------
	; Menu sprites
	;------------------------------------------
	;cration du cadre des menus.
	MenuLayer=CreatePivot(SpriteLayer);
	SP_MenuBorder=SpLoadSprite("data\img\MenuBorder.bmp",MenuLayer)
	ScaleSprite(SP_MenuBorder,0.5,0.5)
	EntityOrder(SP_MenuBorder,-7)	
	
	
	MainMenu.Tmenu=createMenu()
	CreateLineMenu("data\img\NewGame.bmp",    "START",MainMenu  ,0,0.3 ,0.7,0.18)
	CreateLineMenu("data\img\HighScore.bmp","HIGHSCORE",MainMenu,0,0   ,0.7,0.33)
	CreateLineMenu("data\img\Quit.bmp",          "QUIT",MainMenu,0,-0.3,0.7,0.18)
	
	GameMenu.Tmenu=createMenu()
	CreateLineMenu("data\img\Continue.bmp","CONTINUE",GameMenu,0,0.3  ,0.8,0.2)
	CreateLineMenu("data\img\Last.bmp",        "LAST",GameMenu,0,0    ,0.8,0.2)
	CreateLineMenu("data\img\Leave.bmp",      "LEAVE",GameMenu,0,-0.3 ,0.8,0.2)
	
	GameOverMenu.Tmenu=createMenu()
	CreateLineMenu("data\img\Last.bmp",  "LAST",GameOverMenu,0,0.15  ,0.8,0.2)
	CreateLineMenu("data\img\Leave.bmp","LEAVE",GameOverMenu,0,-0.15 ,0.8,0.2)
			
	;------------------------------------------
	; in game sprites
	;------------------------------------------
	inGameSpLayer=CreatePivot(SpriteLayer);
	;Mouse Manual 
	SP_Mouse=SpLoadSprite("data\img\Mouse.bmp",inGameSpLayer)
	ScaleSprite(SP_Mouse,0.2,0.2)
	MoveEntity SP_Mouse,-0.9,0.6,0
	
	;------------------------------------------
	; String sprites font.
	;------------------------------------------
	InitPoliceSprite()
	
End Function