;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Global TabCheckPtBox%[20]
Global nbChkPt%

Global CurrentChkPt%

Global CheckPtLoose%

Global GameOver
Global GameWin

Global TimeRefWaitReplace ;Temps de rfrence pour l'attente du repalcement de la bille ou de la fin du jeu.
Const WaitReplaceDelay=1000;temps d'atente en millisecondes pour le preplacement de la bille 

;quand la bille touche une boite, elle rapparaitra  l'emplacement de celle-ci si on a perdu.

Function LoadCheckPoints(path$)
	fich=ReadFile(path)

		;Partie [checkPoitnBox] (1 ou plusieur cube)
		file_gotoSection(fich,"checkPoitnBox")
		Local i%=0
		While (File_ReadString(Fich)<>"[endBox]")
			TabCheckPtBox[i]=LoadCheckPointBox(fich)
			i=i+1
		Wend 
		nbChkPt=i
		
		
		;Partie [CheckPointLoose] (1 ou plusieur cube)
		file_gotoSection(fich,"CheckPointLoose")
		CheckPtLoose=LoadCheckPointBox(fich)
	
	CloseFile(fich)
End Function
;-------------------------------------------------
Function LoadCheckPointBox%(fich)
		;coordones du check point	
		Local x#=File_ReadFloat(fich)*coef
		Local y#=File_ReadFloat(fich)*coef
		Local z#=File_ReadFloat(fich)*coef
		Local SizeX#=File_ReadFloat(fich)*coef
		Local SizeY#=File_ReadFloat(fich)*coef
		Local SizeZ#=File_ReadFloat(fich)*coef	
			
		CheckPtBox=CreateCube()
		PositionEntity(CheckPtBox,x,y,z)
		ScaleEntity(CheckPtBox,SizeX,SizeY,SizeZ)
			
		;affichahe ou non des checkPoint en rouge
		If ChkPtVisible
			EntityColor (CheckPtBox,180,100,100)
			EntityAlpha (CheckPtBox,0.5)
		Else
		HideEntity(CheckPtBox)
		EndIf 
	Return CheckPtBox
End Function
;-------------------------------------------------
Function CheckPoint()
	;Gestion des checkPoint	
	If (CurrentChkPt+1<nbChkPt) Then 
		If(MeshesIntersect(TabCheckPtBox[CurrentChkPt+1],ball\mesh)) Then 
			CurrentChkPt=CurrentChkPt+1
			PositionEntity(SP_ProgressBarCursor,-0.9+ Float 2 * CurrentChkPt/(nbChkPt-1) ,-0.8,0)
		EndIf
	Else 
		GameWin=WaitFinDuJeu()
	EndIf
	
	;Si on perds.
	If Not cfg_DebugFreeBall Then
		If(MeshesIntersect(CheckPtLoose,ball\mesh) Or ball\y<=RayonSphere*2) Then GameOver=WaitFinDuJeu()
	EndIf
	
	
End Function
;-------------------------------------------------
Function WaitFinDuJeu()
	;si C'est le dbut de l'attente.
	If TimeRefWaitReplace=0 Then TimeRefWaitReplace =MilliSecs()
	
	If MilliSecs()>=TimeRefWaitReplace+WaitReplaceDelay Then 	
		TimeRefWaitReplace=0
		Return True
	Else 
		Return False
	EndIf
End Function