;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Global LeaveGame
Global Chrono#

;----------------------------------------------------------------------
;affiche le menu Principal.
;----------------------------------------------------------------------
Function Run_Menu()
	PauseChannel(ChnlBallRoll)
	Local QuitGame=False
	ShowMenu(MainMenu)
	FlushMouse()
	While Not(KeyHit(1) Or QuitGame)
		;gestion des action  la souris
		loadMouseInfo()
		
		Local Action$=MenuExecute(MainMenu)
		Select (Action)
			Case "START":Run_Game()
				ShowMenu(MainMenu)
			Case "QUIT":quitGame=True
			Case "HIGHSCORE":Run_HighScore()
				ShowMenu(MainMenu)	
		End Select 

		FUNC_UpdateCamera(ReplayMode)
			
		afficheScreen()		
	Wend

End Function
;----------------------------------------------------------------------
;affiche le tableau des meilleurs Scores.
;----------------------------------------------------------------------
Function Run_HighScore()
	PauseChannel(ChnlBallRoll)
	LoadHighScore$()	
	FlushMouse()
	FlushKeys()
	HideAllMenu()
	
	Local HighScoreLayer=CreatePivot(SpriteLayer)
	;Titre
	Local Title.TSpriteString=CreateSpriteString(HighScoreLayer)
	If NbHighScore<>0 Then
		PositionStringSprite(Title,-5,13,40)
		SetSpriteString(Title,"HIGH SCORE :")
		
	Else	
		PositionStringSprite(Title,-10,0,20)
		SetSpriteString(Title,"....NO HIGH SCORE....")
	EndIf

	;Scores : 
	Local HScTab.TSpriteString[10]
	For i =0 To NbHighScore-1
		HScTab[i]=CreateSpriteString(HighScoreLayer)
		PositionStringSprite(HScTab[i],-12,8-(2*i),40)
		SetSpriteString(HScTab[i], RSet((i+1),2) +" : "+Replace(LSet(TabHighScore[i]\PlayerName,15)," ",".")+MilisecsToSt(TabHighScore[i]\PlayerTime))
	Next
	

	;Affichage
	While Not( KeyHit(1) Or MouseHit(1))
		
		FUNC_UpdateCamera(ReplayMode)
			
		afficheScreen()	
		
		 	
	Wend
	
	;Supprssion du High Score	
	FreeSpriteString(Title)
	
	For i =0 To NbHighScore-1
		FreeSpriteString(HScTab[i])
	Next
	
	FreeEntity HighScoreLayer
	
End Function
;----------------------------------------------------------------------
;Affiche la fin de la partie.(Perdu)
;----------------------------------------------------------------------
Function Run_GetName$()
	PauseChannel(ChnlBallRoll)
	HideEntity (inGameSpLayer)	
	FlushKeys()
	Local GetNameLayer=CreatePivot(SpriteLayer)
	;Titre
	Local Title.TSpriteString=CreateSpriteString(GetNameLayer)
	PositionStringSprite(Title,-7,10,40)
	SetSpriteString(Title,"Enter Your Name :")
	;Nom Entr au clavier
	Local SpName.TSpriteString=CreateSpriteString(GetNameLayer)
	PositionStringSprite(SpName,-7,5,40)
	Local St$

	While Not( KeyHit(28) Or MouseHit(1))
		
		;Gestion de l'entre du nom au clavier
		Local keyTyped%=GetKey()
		;si on tape un caractre.
		If keyTyped>=32 And keyTyped<=132 And Len(St)<=12 Then 
			st = St + Chr(keyTyped)
		EndIf 
		;Si on Tape "Delete"
		If keyTyped=8 And Len(St)>0 Then St=Left(st,Len(st)-1)
		
		
		SetSpriteString(SpName,"->"+st+"<-")

		;Gestion du replay
		PlayFrame()
	
		FUNC_UpdateCamera(ReplayMode)
			
		afficheScreen()
	Wend
	
	FreeSpriteString(Title)
	FreeSpriteString(SpName)
	FreeEntity GetNameLayer
	
	If St="" Then St="A.Nonym"
	
	Return St
	
End Function
;----------------------------------------------------------------------
;Affiche la fin de la partie.(Perdu)
;----------------------------------------------------------------------
Function Run_GameOver()
	PauseChannel(ChnlBallRoll)
	HideEntity (inGameSpLayer)
	HideAllMenu()
	FlushMouse()	
	Local SP_GameOver=SpLoadSprite("data\img\GameOver.png",SpriteLayer)

	ResetReplay()
	FlushMouse()
	While Not(KeyHit(1) Or MouseHit(1))
		;Affichage du Game OVER
		Local cpt%
		Cpt=Cpt+1
		SpSize#=Abs(Cos(cpt*2))
		ScaleSprite(SP_GameOver,SpSize/2,SpSize/2)
		
		;Gestion du replay
		PlayFrame()
		
		;gestion des action  la souris
		loadMouseInfo()
	
		FUNC_UpdateCamera(ReplayMode)

		afficheScreen()
		
		
	Wend
	
	;libration des prites
	FreeEntity(SP_GameOver) 
	
	GameOver=False	
		
	;lancement du menu
	Run_GameOverMenu()
		
	ShowEntity (inGameSpLayer)	
End Function
;----------------------------------------------------------------------
;affiche le menu du game over
;----------------------------------------------------------------------
Function Run_GameOverMenu()	
	PauseChannel(ChnlBallRoll)
	ShowMenu(GameOverMenu)
	FlushMouse()
	Local leaveMenu=False
	While Not( KeyHit(1) Or leaveMenu)
	
		;Gestion du replay
		PlayFrame()

		FUNC_UpdateCamera(ReplayMode)
			
		afficheScreen()	
		;Gestion du menu
		Local Action$=MenuExecute(GameOverMenu)
		Select (Action)
			Case "LAST":leaveMenu=True
				ResetBall(CurrentChkPt)
			Case "LEAVE":leaveMenu=True
				LeaveGame=True
				ResetBall(0)
		End Select 	
	Wend
		
	HideAllMenu()
	ShowEntity (inGameSpLayer)
	
End Function
;----------------------------------------------------------------------
;Affiche la fin de la partie.(Gagne)
;----------------------------------------------------------------------
Function Run_GameWin()
	PauseChannel(ChnlBallRoll)
	ChannelVolume(PlayMusic ("Data\sfx\win.wav"),SfxVolume)
	HideEntity (inGameSpLayer)	
	Local SP_GameOver=SpLoadSprite("data\img\YouWin.png",SpriteLayer)
	ResetReplay()
	FlushMouse()
	While Not( KeyHit(1) Or MouseHit(1))
		;Affichage du Game OVER
		Local cpt%
		Cpt=Cpt+1
		SpSize#=Abs(Cos(cpt))
		ScaleSprite(SP_GameOver,SpSize,SpSize)
		
		;Gestion du replay
		PlayFrame()
	
		FUNC_UpdateCamera(ReplayMode)
			
		afficheScreen()
	Wend
	
	FreeEntity(SP_GameOver) 
	
	;Gestion du Score
	place=ScorePlace(Chrono)
	If place<>-1 Then
		InsertScore(Run_GetName(),Chrono,place)
		SaveHighScore()
	EndIf
		
	Run_HighScore()

End Function
;----------------------------------------------------------------------
;affiche le menu en cours de partie
;----------------------------------------------------------------------
Function Run_inGameMenu()	
	PauseChannel(ChnlBallRoll)
	ShowMenu(GameMenu)
	FlushMouse()
	Local leaveMenu=False
	While Not( KeyHit(1) Or leaveMenu)
		
		FUNC_UpdateCamera(ReplayMode)
			
		afficheScreen()	
		;gestion du Menu
		Local Action$=MenuExecute(GameMenu)
		
		Select (Action)
			Case "CONTINUE":leaveMenu=True
			Case "LAST":leaveMenu=True
				ResetBall(CurrentChkPt)
			Case "LEAVE":leaveMenu=True
				LeaveGame=True
		End Select 	
	Wend
		
	HideAllMenu()
	ShowEntity (inGameSpLayer)
	
End Function
;----------------------------------------------------------------------
;Lance la Partie.
;----------------------------------------------------------------------
Function Run_Game()
	HideAllMenu()
	ShowEntity (inGameSpLayer)
	ResetBall(0)
	CurrentChkPt=-1
	EraseReplay()
	GameOver=False
	GameWin=False 
	LeaveGame=False
	Chrono=0
	
	Local SpChrono.TSpriteString=CreateSpriteString(inGameSpLayer)
	PositionStringSprite(SpChrono,13,10,30)
	
	;main loop
	While Not(GameWin Or LeaveGame)
		
		;Gestion des actions  la souris.
		loadMouseInfo()
	
		FUNC_UpdateCamera(2)
		FUNC_MouseMoveObject()

		If KeyDebug Then FUNC_MoveBall()
		
		;Gestion des objets AutoAnims 
		updateAnimObjects()	
			
		;gestion de la physique (2 fois pour une gestion plus fine)
		For i=0 To 2
			update_PhisicObject(1.2)
		Next
		update_free_objects()
		
		
		;gestion des CheckPoint
		CheckPoint()
		
		;Gestion du Chrono
		Chrono=Chrono+Float 1000/60
		SetSpriteString(SpChrono,MilisecsToSt(Chrono))
		
		
		processGameSound();
		
		
		afficheScreen()
		
		;enregitrement pour le replay
		RecordFrame()
		
		;venements:
		If GameOver Then Run_GameOver()
		If KeyHit(1) Then Run_inGameMenu()
	Wend
	PauseChannel(ChnlBallRoll)
	FreeSpriteString(SpChrono)
	
	If GameWin Then Run_GameWin()

End Function

;----------------------------------------------------------------------
; Affiche tous les objets  l'cran.
;----------------------------------------------------------------------
Function afficheScreen()

	If (Cfg_Reflet) Then doBallReflexion()
	
	;Parie affichage
	UpdateMouseCursor()
	RenderWorld
	
	
	If ShowDebugInfos Then
		ShowFps()
		Text 200,10,"Nb Ode object : "+NbOdeObject
		Text 200,20,"Current Check Point : "+CurrentChkPt
		Text 200,30,"Triangle : "+TrisRendered() 
		Text 200,40,"video Mem : "+100 * AvailVidMem()/TotalVidMem() + "%"
		Text 200,50,"ButDown Time : "+TimeButtonDown
	EndIf 
	
	WaitTimer(FrameTimer) 

	Flip False

End Function