;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Global TabHighScore.TScore[10]
Global NbHighScore%

Type TScore
	Field PlayerName$
	Field PlayerTime#
End Type

;---------------------------------------------------------------------------------
Function LoadHighScore$()
	Local File = OpenFile(RomPath+"\HighScore.dat")
	
	Local i=0
	If file <>0
		While Not Eof(file)
			TabHighScore[i] = New TScore
			TabHighScore[i]\PlayerName=ReadString(File)
			TabHighScore[i]\PlayerTime=ReadInt(File)
			i=i+1
		Wend 
		CloseFile(file)		
	EndIf 
	NbHighScore=i
	
End Function
;---------------------------------------------------------------------------------
Function SaveHighScore()
	Local File = WriteFile(RomPath+"\HighScore.dat")
		For i = 0 To NbHighScore-1
			WriteString(File ,TabHighScore[i]\PlayerName)
			WriteInt(File ,TabHighScore[i]\PlayerTime)
		Next
	CloseFile(file)
End Function
;---------------------------------------------------------------------------------
;Donne La place du Score dans l'ancien classement.
Function ScorePlace%(NewScore%)
	If NbHighScore=0 Then 
		Returned =  0		
	Else	 
		Local i=0 
		Local Place=False ; Indique si on a trouv la place du score.
		While i<NbHighScore And (Not Place)
			Place=TabHighScore[i]\PlayerTime>=NewScore
			i=i+1
		Wend 
		If Place Then
			returned=i-1
		Else
			If i<=9 Then 
				returned=i
			Else
				returned=-1
			EndIf 
		EndIf
	EndIf 
	
	Return Returned
End Function
;---------------------------------------------------------------------------------
Function InsertScore(NewName$,NewScore%,Place%)
	
	If NbHighScore<10 Then 
		TabHighScore[NbHighScore]=New TScore
		NbHighScore=NbHighScore+1	
	EndIf 
	
	For i=NbHighScore-1 To Place+1 Step -1
		TabHighScore[i]\PlayerTime=TabHighScore[i-1]\PlayerTime
		TabHighScore[i]\PlayerName=TabHighScore[i-1]\PlayerName
	Next
	
	TabHighScore[Place]\PlayerTime=NewScore
	TabHighScore[Place]\PlayerName=NewName
End Function



;TEST;;;;;;;;;;;;;;

;Print ScorePlace(1)

;InsertScore("AA",60000000,0)
;InsertScore("BBBB",60000000,1)
;InsertScore("CC",60000000,2)
;InsertScore("DDDDD",60000000,3)
;InsertScore("EEEE",60000000,4)
;InsertScore("FFF",60000000,5)
;InsertScore("G",60000000,6)
;InsertScore("HHHHHH",60000000,7)
;InsertScore("III",60000000,8)
;InsertScore("JJJJJJJ",60000000,9)
;SaveHighScore()


;LoadHighScore$()



;InsertScore("AA",6000,0)
;InsertScore("BB",16000,1)
;InsertScore("AA",26000,2)

;Print ScorePlace(6100)


;Affiche Le High Score
;For i=0 To NbHighScore-1
;	Print ""+i+"  :  "+TabHighScore[i]\PlayerName$+"......"+TabHighScore[i]\PlayerTime#
;Next

;WaitKey


;Affiche Le High Score
;InsertScore("BB",26000,0)


;For i=0 To NbHighScore-1
;	Print ""+i+"  :  "+TabHighScore[i]\PlayerName$+"......"+TabHighScore[i]\PlayerTime#
;Next


;WaitKey




