;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Type TMagnet
	Field ObjMagnet.ODE_Object
	Field ZoneAction#
	Field Force#
End Type

;-------------------------------------------------------------------------
; Effectue un pas d'action de l'aiment
;-------------------------------------------------------------------------
Function Magnets_StepOver()
	For Magnet.TMagnet = Each TMagnet 
		
		Local MagnetMesh=Magnet\ObjMagnet\mesh
		
		Local Dist#=EntityDistance(ball\mesh,MagnetMesh)-RayonSphere
			
		;l'aiment n'a d'action que si la bille entre dans la ZoneAction
		If (dist<=Magnet\ZoneAction) Then	
			Local k#=Magnet\Force / (Dist^2)
			
			Local Xforce#=k*(EntityX(MagnetMesh)-EntityX(ball\mesh))
			Local Yforce#=k*(EntityY(MagnetMesh)-EntityY(ball\mesh))
			Local Zforce#=k*(EntityZ(MagnetMesh)-EntityZ(ball\mesh))
			
			ODE_Add_Relative_Force_To_Object(ball\ODE_ID,Xforce,Yforce,Zforce,0,0,0,2)
			If Not Magnet\ObjMagnet\geomonly Then ODE_Add_Relative_Force_To_Object(Magnet\ObjMagnet\ODE_ID,-Xforce,-Yforce,-Zforce,0,0,0,2)
		EndIf 
	Next
End Function
;-------------------------------------------------------------------------