;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;
Global quitIntro

Function Intro()
	FlushMouse()
	HideAllMenu()
	quitIntro=False
	Delay(2000)
	ShowSprite("Data\img\netoale.png",0.5,0.5)
	
	Local musicIntro%=PlayMusic ("Data\sfx\Shalem_ralelem.wav")
	ChannelVolume(musicIntro,SfxVolume)
	
	ShowSprite("Data\img\Presents.png",0.25,0.25)
	ShowSprite("Data\img\Language.png",0.5,0.5)
	ShowSprite("Data\img\blitzlogo.png",0.35,0.25)
	ShowSprite("Data\img\Physics.png",0.5,0.5)
	ShowSprite("Data\img\ODE.png",0.5,0.5)
	ShowSprite("Data\img\Programmation.png",0.5,0.5)
	ShowSprite("Data\img\Graphycs.png",0.5,0.5)
	ShowSprite("Data\img\Music.png",0.5,0.5)
	ShowSprite("Data\img\Thanx.Bmp",0.5,0.5)
	ShowSprite("Data\img\code(r).Bmp",0.5,0.5)
	ShowSprite("Data\img\Blitzfr.jpg",0.5,0.5)

	If quitIntro StopChannel(musicIntro)
	
	ShowTitle()
	
	
	FlushMouse()
	
End Function
;-----------------------------------------------------------------------------------
Function ShowTitle()
	Local SizeX#=0.7
	Local SizeY#=0.3
	HideAllMenu()
	;Chargement des deux sprites du menu
	Local spTitle1=LoadSprite("Data\img\title1.bmp",2,SpriteLayer)
	Local spTitle2=LoadSprite("Data\img\title2.bmp",1,SpriteLayer)
	ScaleSprite(spTitle1,SizeX,SizeY)
	ScaleSprite(spTitle2,SizeX,SizeY)
	EntityOrder (spTitle1,-2)
	EntityOrder (spTitle2,-1)
	
	;EntityBlend(spTitle1,2)
	EntityAlpha spTitle2,0
	
	;Fade in du srite1
	For i=0 To 100
		EntityAlpha spTitle1,Float i/100
		UpdateWorld
		RenderWorld
		Flip False
		WaitTimer(FrameTimer)
	Next
	
	;Fade in du srite2
	For i=0 To 100
		EntityAlpha spTitle2,Float i/100
		UpdateWorld
		RenderWorld
		Flip False
		WaitTimer(FrameTimer)
	Next
	
	;Fade out du srite1
	For i=100 To 0 Step -1
		EntityAlpha spTitle1,Float i/100
		UpdateWorld
		RenderWorld
		Flip False
		WaitTimer(FrameTimer)
	Next
		
	;Dplacement du Titre vers le haut.
	For i=0 To 100
		PositionEntity(spTitle2,0,Float i/150 ,0)
		UpdateWorld
		RenderWorld
		Flip False
		WaitTimer(FrameTimer)
	Next
	
	;Suppression des deux sprite.
	FreeEntity(spTitle1)
	FreeEntity(spTitle2)
	FlushMouse()
End Function
;-----------------------------------------------------------------------------------
Function ShowMainMenu$()
	Local SizeX#=0.7
	Local SizeY#=0.3
	Local quitMenu=False
	
	;Affichage du titre
	Local spTitle=LoadSprite("Data\img\title2.bmp",2,SpriteLayer)
	ScaleSprite(spTitle,SizeX,SizeY)
	EntityOrder (spTitle,-1)
	PositionEntity(spTitle,0,Float 100/150 ,0)
	
	;Image de fond
	Local BackSprite1=CreateSprite(SpriteLayer)
	Local TexBackSprite1=LoadTexture("Data\img\back.bmp")
	Local TexBackSprite2=LoadTexture("Data\img\back.bmp")
	TextureBlend(TexBackSprite2,3)
	ScaleTexture(TexBackSprite1,0.5,0.5)
	ScaleTexture(TexBackSprite2,1,1)
	EntityTexture(BackSprite1,TexBackSprite1,0,0)
	EntityTexture(BackSprite1,TexBackSprite2,0,1)
	ScaleSprite(BackSprite1,1.4,1.4)
	EntityOrder (BackSprite1,1)
	
	;Cration du menu	
	LoadRomMenu.Tmenu=createMenu()
	
	CreateLineMenu("data\img\Left.bmp",   "LEFT" ,LoadRomMenu,-0.5,0   ,0.3,0.18)
	CreateLineMenu("data\img\Right.bmp",  "RIGHT",LoadRomMenu, 0.5,0   ,0.3,0.18)
	CreateLineMenu("data\img\NewGame.bmp","START",LoadRomMenu,-0.5,-0.5,0.7,0.18)
	CreateLineMenu("data\img\Quit.bmp",   "QUIT",LoadRomMenu,  0.5,-0.5,0.7,0.18)
	
	ShowMenu(LoadRomMenu)
	HideEntity(SP_MenuBorder)
	
	SpRomPreview=CreateSprite(SpriteLayer)
	ScaleSprite(SpRomPreview,0.25,0.25) 
	
	;Chargement des Roms Potentielles  Charger.
	Local TabRoms$[10];10 Roms Maximum (baaad...)
	Local TabPreview[10]
	Local nbRoms%=0
	romDir=ReadDir("Roms") 
	Repeat 
		fileName$="Roms\"+NextFile(romDir)
		If FileType(fileName)=2 And fileName<>"Roms\" And fileName<>"Roms\." And fileName<>"Roms\.." Then
			TabRoms[nbRoms]=fileName 
			TabPreview[nbRoms]=LoadTexture(fileName+"\preview.bmp")
			nbRoms=nbRoms+1
		EndIf
	Until fileName="Roms\"
	CloseDir(romDir)
	
	;Boucle Principale du menu
	Local RomSelected%=0
	While Not(quitMenu)

		Local Action$=MenuExecute(LoadRomMenu)
		Select (Action)
			Case "RIGHT":RomSelected=(RomSelected+1) Mod nbRoms
			Case "LEFT" :RomSelected=RomSelected-1
				If  RomSelected<0 Then RomSelected=RomSelected+nbRoms
				RomSelected = RomSelected Mod nbRoms
			Case "START":RomName$=TabRoms[RomSelected]
				quitMenu=True
			Case "QUIT":RomName$=""				
				quitMenu=True
		End Select 
		;Affichage du preview.
		If NbRoms<>0 Then
			EntityTexture(SpRomPreview,TabPreview[RomSelected])
		EndIf 
		
		
		;gestion du background
		Cpt%=(Cpt+1) Mod 360
		PositionTexture(TexBackSprite1,0.2*Cos(Cpt),0.3*Sin(Cpt))
		PositionTexture(TexBackSprite2,-0.5*Sin(Cpt),-0.75*Cos(Cpt))
		
		;affichage
		RenderWorld
		UpdateMouseCursor()
		WaitTimer(FrameTimer)
		;Text 10,10,RomSelected+" : "+TabRoms[RomSelected]
		
		Flip False
	Wend
	
	;Suprssion des images de preview
	FreeEntity(SpRomPreview)
	For i=0 To nbRoms-1
		FreeTexture(TabPreview[i])
	Next 
				
	;supprssion du menu et du titre.
	FreeMenu(LoadRomMenu)
	FreeEntity(spTitle)
	
	;suppression de l'image de fond.
	FreeEntity(BackSprite1) 
	FreeTexture(TexBackSprite1)
	FreeTexture(TexBackSprite2)
	
	ShowEntity(SP_MenuBorder)
	Return RomName
End Function 
;-----------------------------------------------------------------------------------
Function ShowSprite(Path$,SizeX#,SizeY#)
	If 	quitIntro Then Return
	Local sprite=LoadSprite(Path,1,SpriteLayer)
	ScaleSprite(sprite,SizeX,SizeY)
	EntityOrder (sprite,-1)
	
	;fade IN
	Local i=0
	While i<=100 And (Not quitIntro)
		EntityAlpha sprite,Float i/100
		UpdateWorld
		RenderWorld
		Flip False
		WaitTimer(FrameTimer)
		If GetKey() Or MouseDown(1) Then quitIntro=True
		i=i+1
	Wend
	;Waiting
	Local j=0 
	While j<=200 And (Not quitIntro)
		WaitTimer(FrameTimer)
		If GetKey() Or MouseDown(1) Then quitIntro=True
		j=j+1
	Wend	
	;fade OUT
	While i>=0
		EntityAlpha sprite,Float i/100
		UpdateWorld
		RenderWorld
		Flip False
		WaitTimer(FrameTimer)
		If GetKey() Or MouseDown(1) Then quitIntro=True
		i=i-1
	Wend 
	
	FreeEntity sprite
End Function
;-----------------------------------------------------------------------------------