;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

;dernier menu qui eu le focus pour le son 
Global LastMenu$

Type TLineMenu
	Field MenuName$
	Field Sprite%
	Field x#,y#,Height#,Whidth#
End Type 
;----------------------------------------------------------------------
Type Tmenu
	Field Layer%
	Field MenuLines.TLineMenu[6]
	Field NbLine%
End Type

;----------------------------------------------------------------------
;----------------------------------------------------------------------
;----------------------------------------------------------------------
; Gestion du Menu
;----------------------------------------------------------------------
Function CreateMenu.Tmenu()
	Local Result.Tmenu=New Tmenu
		Result\Layer=CreatePivot(MenuLayer)
		Result\NbLine=0
	Return Result
End Function
;----------------------------------------------------------------------
Function Menu_AddLine(menu.Tmenu,Line.TLineMenu)
	menu\MenuLines[menu\NbLine]=Line
	menu\NbLine=menu\NbLine+1
End Function 
;----------------------------------------------------------------------
Function MenuExecute$(menu.Tmenu)
	Local Returned$="0"
	For i = 0 To Menu\NbLine-1	
		Local Focus$=LineExecute(Menu\MenuLines[i])
		If focus<>"0" Then Returned=focus
	Next 
	LastMenu=Returned
	FlushMouse()
	Return(Returned)
End Function 
;----------------------------------------------------------------------
Function HideAllMenu()
	HideEntity(inGameSpLayer)
	HideEntity(MenuLayer)
	PauseChannel(ChnlMusicMenu)
End Function 
;----------------------------------------------------------------------
Function ShowMenu(menu.Tmenu)
	ShowEntity (MenuLayer)
	HideEntity(inGameSpLayer)
	;on chache tous les menus sauf celui qui nous intrraise.
	For M.Tmenu = Each Tmenu
		If m=menu Then
			ShowEntity(m\layer)
		Else
			HideEntity(m\layer)
		End If
	Next
	ResumeChannel(ChnlMusicMenu)
	
End Function 
;----------------------------------------------------------------------
;----------------------------------------------------------------------
;----------------------------------------------------------------------
; Gestion des lignes du menu
;----------------------------------------------------------------------
Function CreateLineMenu(SpriteImagePath$,Name$,Menu.TMenu,x#,y#,whidth#,height#)
	Result.TLineMenu=New TlineMenu
	Result\Sprite=SPLoadSprite(SpriteImagePath,Menu\Layer)
	ScaleSprite(Result\Sprite,whidth/2,height/2);/2 because there is a bug in "ScaleSprite" function
	PositionEntity(Result\Sprite,x,y,0)
	EntityOrder(Result\Sprite,-8)	
	Result\x=x
	Result\Y=y
	Result\whidth=whidth
	Result\height=height
	Result\MenuName=Name
	;ajout de la ligne dans le menu	
	Menu_AddLine(Menu,Result)
End Function 

;----------------------------------------------------------------------
; Renvoie true si la sousis est sur la ligne, faux sinon.
;----------------------------------------------------------------------
Function LineFocused(Line.TLineMenu)
	Local Mx#=PixelXCoordToSpriteCoord(MouseX())
	Local My#=PixelYCoordToSpriteCoord(MouseY())

		
	Return (Mx>Line\x-Line\Whidth/2) And (My>Line\Y-Line\Height/2) And (Mx<Line\x+Line\Whidth/2) And (My<Line\Y+Line\Height/2)
	
End Function 
;----------------------------------------------------------------------
; Si la souris est sur la ligne, la ligne grossi, si on clique, on execute l'action correspondante
;----------------------------------------------------------------------
Function LineExecute$(Line.TLineMenu)
	Local result$="0"
	If LineFocused(Line) Then
		ScaleSprite(Line\Sprite,Line\whidth/2*1.5,Line\height/2*1.5)
		If LastMenu="0" Then PlaySound(WavMenuChng)
		If MouseHit(1) Then 
			result = Line\MenuName
			PlaySound(WavMenuClick)
		Else 
			result ="1" ; 1 = Focussed 
		End If
	Else 
		ScaleSprite(Line\Sprite,Line\whidth/2,Line\height/2);/2 because there is a bug in "ScaleSprite" function
	EndIf
	Return result
End Function
;----------------------------------------------------------------------
Function FreeMenu(Menu.TMenu)
	For i = 0 To Menu\NbLine-1	
		FreeEntity(Menu\MenuLines[i]\sprite)
		Delete(Menu\MenuLines[i])
	Next 
	FreeEntity(Menu.TMenu\Layer)
	Delete Menu
End Function