;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

Type TSoundBox
	Field Mesh%
	Field sound%
	Field Channel%
End Type

Global WavMenuChng
Global WavMenuClick
Global ChnlMusicMenu
Global ChnlBallRoll 

;derniere vitesse de la bille
Global LastYawVel#,LastPitchVel#

;----------------------------------------------------------------
Function InitSound()
	;Chargement des sons, 
	WavMenuChng = LoadSound("data\sfx\MenuChng.wav") 
	WavMenuClick = LoadSound("data\sfx\MenuOk.wav")
	WavMusicMenu = LoadSound("data\sfx\menu-loop.wav")
	WavBallRoll = LoadSound("data\sfx\BallRoll.wav")
	;volume des sons.
	SoundVolume(WavMenuChng ,SfxVolume)
	SoundVolume(WavMenuClick,SfxVolume)
	SoundVolume(WavMusicMenu,SfxVolume)
	SoundVolume(WavBallRoll ,SfxVolume)
	;LoopSound du menu
	LoopSound(WavMusicMenu)
	ChnlMusicMenu = PlaySound(WavMusicMenu)
	PauseChannel(ChnlMusicMenu)
	;loop du brouit de la bille qui roule
	LoopSound(WavBallRoll)
	ChnlBallRoll = PlaySound(WavBallRoll)
	PauseChannel(ChnlBallRoll )
End Function
;----------------------------------------------------------------
Function processGameSound()
	
	;roulement	
	ODE_Get_Object_Angular_Velocity(ODE_ID,ball)
	vitesse#=Sqr(Ball\angvelx^2+Ball\angvely^2+Ball\angvelz^2)/3
	If vitesse>2 Then vitesse =2
	
	ResumeChannel(ChnlBallRoll)
	ChannelPitch(ChnlBallRoll,44000*vitesse)
	ChannelVolume(ChnlBallRoll,SfxVolume*vitesse)
	
	;gestion des sound Box
	For SoundBox.TSoundBox= Each TSoundBox 
		If(MeshesIntersect(SoundBox\mesh,ball\mesh)) Then 
			If Not ChannelPlaying(SoundBox\channel) Then SoundBox\channel=PlaySound(SoundBox\sound)
		EndIf 
	Next
	
End Function
;----------------------------------------------------------------
Function LoadSoundBox(path$)
	fich=ReadFile(path)

		;Partie [SoundBox] (1 ou plusieur cube)
		file_gotoSection(fich,"SoundBox")
		
		While (File_ReadString(Fich)<>"[endBox]")
			;coordones du check point	
			Local x#=File_ReadFloat(fich)*coef
			Local y#=File_ReadFloat(fich)*coef
			Local z#=File_ReadFloat(fich)*coef
			Local SizeX#=File_ReadFloat(fich)*coef
			Local SizeY#=File_ReadFloat(fich)*coef
			Local SizeZ#=File_ReadFloat(fich)*coef	
			
			Local soundbox.TsoundBox = New TSoundBox
			soundbox\mesh=CreateCube()
			PositionEntity(soundbox\mesh,x,y,z)
			ScaleEntity(soundbox\mesh,SizeX,SizeY,SizeZ)
			
			;Chargement du Wav
			soundbox\sound=LoadSound(StrGetPath(path)+"\"+file_ReadString(fich))
			SoundVolume(soundbox\sound,SfxVolume)
			
			;affichahe ou non des checkPoint en vert
			If ChkPtVisible
				EntityColor (soundbox\mesh,100,180,100)
				EntityAlpha (soundbox\mesh,0.5)
			Else
				HideEntity(soundbox\mesh)
			EndIf
		Wend 
	CloseFile(fich)
End Function