;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;
Global SpFont

;Permet d'afficher une String de longueur Max 256.
Type TSpriteString
	Field TabSprite[256]
	Field StringHandle%; ce ci est un pivot qui permet de dplacer toutes les tettres  la fois.
End Type



;Chargement de la Polyce de caractre.
Function InitPoliceSprite()
	SpFont=LoadAnimTexture("data\img\Polyce.bmp",2,32,32,0,100)	
End Function 
;------------------------------------------------------------------------------
;Cre un objet Graphique compos de plusieurs Sprites.
Function CreateSpriteString.TSpriteString(Parent%)
	Local SpSt.TSpriteString= New TSpriteString
	SpSt\StringHandle=CreatePivot(Parent)
	Return SpSt
End Function
;------------------------------------------------------------------------------
;Dtruit L'objet 
Function FreeSpriteString(SpSt.tSpriteString)
	For i = 0 To 255
		If SpSt\TabSprite[i]<>0 Then FreeEntity(SpSt\TabSprite[i])
	Next
	Delete SpSt
End Function 
;------------------------------------------------------------------------------
;Met  jour le texte de l'objet.
Function SetSpriteString(SpSt.tSpriteString,St$)
	For i = 0 To Len(St)-1
		;si le sprite n'est pas encore cr, on le cre.
		If SpSt\TabSprite[i]=0 Then
			SpSt\TabSprite[i]=CreateSprite(SpSt\StringHandle)
			EntityOrder (SpSt\TabSprite[i],-1)
			PositionEntity(SpSt\TabSprite[i],i*1,0,0)
		EndIf	
		 	
		;on affecte la texture de la lettre au bon Sprite.
		EntityTexture(SpSt\TabSprite[i],SpFont,Asc(Mid(st,i+1,1))-32)
	Next
	;on efface le Reste des lettres (si l'ancienne string tait plus longue)
	For i = Len(St) To 255
		If SpSt\TabSprite[i]<>0 Then 
			FreeEntity(SpSt\TabSprite[i])
			SpSt\TabSprite[i]=0
		EndIf
	Next	
End Function 
;------------------------------------------------------------------------------
Function PositionStringSprite(SpSt.tSpriteString,x#,y#,z#)
	PositionEntity(SpSt\StringHandle,x#,y#,z#)
End Function 