;-------------------------------------------------;
;-
;-   Written by  :       The Ntoale 2004
;-
;-------------------------------------------------;

;- stepvalue# = physics Step value 
Const OdeStepvalue#=0.03
;- mu# , mu2# = friction in primary And secondary directions
Const OdeMu#=10
Const OdeMu2#=0
;- bounce# = resitution ( 1 = restitute equal force ; 0 = no restitution)
Const OdeBounce#=.6
;- bounce_vel# = minimum incoming force necesasry To bounce
Const OdeBounce_vel#=0.01
;- soft_erp# = contact softness parameter
Const OdeSoft_erp#=0.6
;- soft_cfm# = contact softness parameter
Const OdeSoft_cfm#=0
;- motion1# = allows simulaion of moving surface (like a conveyor belt) - primary dir
Const OdeMotion1#=0.1
;- motion2# = allows simulaion of moving surface (like a conveyor belt) - secondary dir
Const OdeMotion2#=0
;- slip1# = slip in friction direction 1
Const OdeSlip1#=0
;- slip2# = slip in friction direction 2
Const OdeSlip2#=0
;			- flags = values of required contact properties combined into 1 number...
;				1		dContactSlip1			0x080
;				2		dContactSlip2			0x100
;				4		dContactSoftERP			0x008
;				8		dContactSoftCFM			0x010
;				16		dContactBounce			0x004
;				32		dContactMu2				0x001
;				64		dContactApprox0			0x0000
;				128		dContactApprox1_1		0x1000
;				256		dContactApprox1_2		0x2000
;				512		dContactApprox1			0x3000
;				1024	dContactFDir1			0x002
;				2048	dContactMotion1			0x020
;				4096	dContactMotion2			0x040
Const Flags#=4


;-------------------------------------------------------------------------------------------------------------------------
;-------------------------------------------------------------------------------------------------------------------------


Global NbOdeObject#=0


Function update_PhisicObject(Coefk#)
	Magnets_StepOver()
	ODE_Worldstep(Coefk*OdeStepvalue,OdeMu,OdeMu2,OdeBounce,OdeBounce_vel,OdeSoft_erp,OdeSoft_cfm,OdeMotion1,OdeMotion2,OdeSlip1,OdeSlip2,Flags)
	update_object(Ball)
End Function
;-------------------------------------------------------------------------------------------------------------------------
Function update_object(ent.ODE_Object)
	;update the Blitz entities
	ODE_Get_Object_Rotation(ent\ODE_ID , ent)
	ODE_Get_Object_Position(ent\ODE_ID , ent)
End Function
;-------------------------------------------------------------------------------------------------------------------------
Function update_all_objects()
	NbOdeObject=0
	;update all the Blitz entities
	For ent.ODE_Object = Each ODE_Object
		update_object(ent)
		NbOdeObject=NbOdeObject+1		
	Next
End Function
;-------------------------------------------------------------------------------------------------------------------------
Function update_Free_objects()
	If objColVisible Then
		update_all_objects()
	Else
		;si on n'affiche pas les objets ratchs aux ODE,
		;alors a sert  rien des les mettre tous  jours, on ne met  jour que ceux qui sont visibles (optimisation)
		Local i%
		For i = 0 To NbActiveObjectCol-1
			update_object(TabActiveObjectCol[i])
		Next 
	EndIf
End Function

